from machine import Pin, PWM
from utime import sleep

servo = None
buzzer = None

grad0 = 500000
grad90 = 1500000

tones = {
"cs6": 1109,
"fs5" : 740,
"d6" : 1175,
"c6" : 1047,
"f5" : 698,
"b5" : 988,
"e5" : 659,
"bf5" : 932,
"ef5" : 622,
"b4" : 494,
"g5" : 784,
}

song = ["cs6", "fs5", "fs5", "cs6", "fs5", "fs5", "cs6", "fs5", "d6", "fs5", 
"cs6", "fs5", "fs5", "cs6", "fs5", "fs5", "cs6", "fs5", "d6", "fs5",
"cs6", "fs5", "fs5", "cs6", "fs5", "fs5", "cs6", "fs5", "d6", "fs5",
"cs6", "fs5", "fs5", "cs6", "fs5", "fs5", "cs6", "fs5", "d6", "fs5",
"cs6", "fs5", "fs5", "cs6", "fs5", "fs5", "cs6", "fs5", "d6", "fs5",
"cs6", "fs5", "fs5", "cs6", "fs5", "fs5", "cs6", "fs5", "d6", "fs5",
"c6", "f5", "f5", "c6", "f5", "f5", "c6", "f5", "cs6", "f5",
"c6", "f5", "f5", "c6", "f5", "f5", "c6", "f5", "cs6", "f5",
"cs6", "fs5", "fs5", "cs6", "fs5", "fs5", "cs6", "fs5", "d6", "fs5",
"cs6", "fs5", "fs5", "cs6", "fs5", "fs5", "cs6", "fs5", "d6", "fs5",
"c6", "f5", "f5", "c6", "f5", "f5", "c6", "f5", "cs6", "f5",
"c6", "f5", "f5", "c6", "f5", "f5", "c6", "f5", "cs6", "f5",
"b5", "e5", "e5", "b5", "e5", "e5", "b5", "e5", "c6", "e5",
"b5", "e5", "e5", "b5", "e5", "e5", "b5", "e5", "c6", "e5",
"bf5", "ef5", "ef5", "bf5", "ef5", "ef5", "bf5", "ef5", "b5", "ef5",
"bf5", "ef5", "ef5", "bf5", "ef5", "ef5", "bf5", "ef5", "b5", "ef5",
"b5", "e5", "e5", "b5", "e5", "e5", "b5", "e5", "c6", "e5",
"b5", "e5", "e5", "b5", "e5", "e5", "b5", "e5", "c6", "e5",
"bf5", "ef5", "ef5", "bf5", "ef5", "ef5", "bf5", "ef5", "b5", "ef5",
"bf5", "ef5", "ef5", "bf5", "ef5", "ef5", "bf5", "ef5", "b5", "ef5",
"fs5", "b4", "b4", "fs5", "b4", "b4", "fs5", "b4", "g5", "b4",
"fs5", "b4", "b4", "fs5", "b4", "b4", "fs5", "b4", "g5", "b4",
"fs5", "b4", "b4", "fs5", "b4", "b4", "fs5", "b4", "g5", "b4",
"fs5", "b4", "b4", "fs5", "b4", "b4", "fs5", "b4", "g5", "b4",
"fs5", "b4", "b4", "fs5", "b4", "b4", "fs5", "b4", "g5", "b4",
"fs5", "b4", "b4", "fs5", "b4", "b4", "fs5", "b4", "g5", "b4",
"fs5", "b4", "b4", "fs5", "b4", "b4", "fs5", "b4", "g5", "b4",
"fs5", "b4", "b4", "fs5", "b4", "b4", "fs5", "b4", "g5", "b4"]

def playtone(frequency):
    if isinstance(buzzer, Pin):
        initBuzzer()
            
    buzzer.duty_u16(1000)
    buzzer.freq(frequency)

def bequiet():
    if isinstance(buzzer, Pin):
        initBuzzer() 
    buzzer.duty_u16(0)

def playsong(mysong):
    for i in range(len(mysong)):   
        if (mysong[i] == "P"):
            bequiet()
        else:
            playtone(tones[mysong[i]])
        sleep(0.2)
        
    bequiet()

def initServo():
    global servo
    servo = PWM(Pin(0))
    servo.freq(50)
    
def resetServo():
    global servo
    servo = Pin(8, Pin.IN, Pin.PULL_UP)

def initBuzzer():
    global buzzer
    buzzer = PWM(Pin(1))

def resetBuzzer():
    global buzzer
    buzzer = Pin(9, Pin.IN, Pin.PULL_UP)

while True:
    initServo()
    servo.duty_ns(grad90)
    sleep(0.5)
    servo.duty_ns(grad0)
    sleep(0.5)
    resetServo()
    sleep(0.2)
    initBuzzer()
    sleep(0.2)
    playsong(song)
    sleep(0.2)
    resetBuzzer()
    sleep(0.2)
    

