#Module zum ansteuern der GPIOs und
#erzeugen eines PWM Signals
from machine import Pin, PWM
from utime import sleep

#der Buzzer ist am GPIO1 angeschlossen
buzzer = PWM(Pin(1))

#Tonname & Frequenz in einem Dictionary mappen
tones = {
"cs6": 1109,
"fs5" : 740,
"d6" : 1175,
"c6" : 1047,
"f5" : 698,
"b5" : 988,
"e5" : 659,
"bf5" : 932,
"ef5" : 622,
"b4" : 494,
"g5" : 784,
}

#Töne vom Lied
song = ["cs6", "fs5", "fs5", "cs6", "fs5", "fs5", "cs6", "fs5", "d6", "fs5", 
"cs6", "fs5", "fs5", "cs6", "fs5", "fs5", "cs6", "fs5", "d6", "fs5",
"cs6", "fs5", "fs5", "cs6", "fs5", "fs5", "cs6", "fs5", "d6", "fs5",
"cs6", "fs5", "fs5", "cs6", "fs5", "fs5", "cs6", "fs5", "d6", "fs5",
"cs6", "fs5", "fs5", "cs6", "fs5", "fs5", "cs6", "fs5", "d6", "fs5",
"cs6", "fs5", "fs5", "cs6", "fs5", "fs5", "cs6", "fs5", "d6", "fs5",
"c6", "f5", "f5", "c6", "f5", "f5", "c6", "f5", "cs6", "f5",
"c6", "f5", "f5", "c6", "f5", "f5", "c6", "f5", "cs6", "f5",
"cs6", "fs5", "fs5", "cs6", "fs5", "fs5", "cs6", "fs5", "d6", "fs5",
"cs6", "fs5", "fs5", "cs6", "fs5", "fs5", "cs6", "fs5", "d6", "fs5",
"c6", "f5", "f5", "c6", "f5", "f5", "c6", "f5", "cs6", "f5",
"c6", "f5", "f5", "c6", "f5", "f5", "c6", "f5", "cs6", "f5",
"b5", "e5", "e5", "b5", "e5", "e5", "b5", "e5", "c6", "e5",
"b5", "e5", "e5", "b5", "e5", "e5", "b5", "e5", "c6", "e5",
"bf5", "ef5", "ef5", "bf5", "ef5", "ef5", "bf5", "ef5", "b5", "ef5",
"bf5", "ef5", "ef5", "bf5", "ef5", "ef5", "bf5", "ef5", "b5", "ef5",
"b5", "e5", "e5", "b5", "e5", "e5", "b5", "e5", "c6", "e5",
"b5", "e5", "e5", "b5", "e5", "e5", "b5", "e5", "c6", "e5",
"bf5", "ef5", "ef5", "bf5", "ef5", "ef5", "bf5", "ef5", "b5", "ef5",
"bf5", "ef5", "ef5", "bf5", "ef5", "ef5", "bf5", "ef5", "b5", "ef5",
"fs5", "b4", "b4", "fs5", "b4", "b4", "fs5", "b4", "g5", "b4",
"fs5", "b4", "b4", "fs5", "b4", "b4", "fs5", "b4", "g5", "b4",
"fs5", "b4", "b4", "fs5", "b4", "b4", "fs5", "b4", "g5", "b4",
"fs5", "b4", "b4", "fs5", "b4", "b4", "fs5", "b4", "g5", "b4",
"fs5", "b4", "b4", "fs5", "b4", "b4", "fs5", "b4", "g5", "b4",
"fs5", "b4", "b4", "fs5", "b4", "b4", "fs5", "b4", "g5", "b4",
"fs5", "b4", "b4", "fs5", "b4", "b4", "fs5", "b4", "g5", "b4",
"fs5", "b4", "b4", "fs5", "b4", "b4", "fs5", "b4", "g5", "b4"]

#Spielt einen Ton in einer Frequenz ab
def playtone(frequency):           
    buzzer.duty_u16(1000)
    buzzer.freq(frequency)

#Verstummt den Buzzer
def bequiet():
    buzzer.duty_u16(0)

#Spielt das Lied ab
def playsong(mysong):
    #läuft über die Liste mit den Tönen
    for i in range(len(mysong)):
        #abspielen eines Tones aus der Liste mit dem Index i
        playtone(tones[mysong[i]])
        #kleine Pause von 200 Millisekunden
        sleep(0.2)
    #verstummen des Buzzers
    bequiet()

#Abspielen des Liedes
playsong(song)